#include "smtp.h"

extern smtpi jtin;

void smtpstats_init()
   {
   pth_mutex_t mutex = PTH_MUTEX_INIT;
   pth_mutex_acquire(&mutex, TRUE, NULL);
   time_t now_unixtime;
   struct tm now;
   pool p=pool_new();
   char *lcFile;
   int liYear;

   smtp_PoolsReg(7601, p);

   now_unixtime = time(NULL);
   gmtime_r(&now_unixtime, &now);
   liYear =now.tm_year+1900;

   // pokud je soubor nahranej, testuj rok
   if (jtin->smtpstats!=NULL)
      {
      if (j_atoi(xmlnode_get_attrib(jtin->smtpstats,"id"),0)!=liYear)
         {
         xmlnode_free(jtin->smtpstats);
         jtin->smtpstats=NULL;
         }
      }

   if (jtin->smtpstats==NULL)
      {
      lcFile=spools(p,jtin->smtpstats_folder,"/",smtp_itoa( p,liYear),".xml",p);
      if ((jtin->smtpstats=xmlnode_file(lcFile))==NULL)
         { // file not exist or any other bug

         if (access(lcFile,F_OK)!=0)
            log_error("smtp","Transport cannot load smtpstats file (%s).",lcFile);

         // create new file
         jtin->smtpstats=xmlnode_new_tag("year");
         smtp_PoolsReg(7600, xmlnode_pool(jtin->smtpstats));
         smtp_PoolsSettmp(xmlnode_pool(jtin->smtpstats), 0);
         smtp_PoolsSetData(xmlnode_pool(jtin->smtpstats), (void*) jtin->smtpstats);
         xmlnode_put_attrib(jtin->smtpstats,"id",smtp_itoa( p,liYear));
         }
      }   

   pool_free(p);
   pth_mutex_release(&mutex);
   }

void smtpstats_add(char *lcFrom, char *lcTo)
   {
   time_t now_unixtime;
   struct tm now;
   xmlnode loDay,loJID,loCopy,loRcpt,loSMTPstats;
   pool p=pool_new();
   char *lcDate,*lcJID,*lcFile;
   int lii,liLimit;
   #ifdef SMTP_DB
    SMTP_DEBUG(SMTP_ZONE,"SMPT: Registration SMTPSTATS pool");
   #endif
   smtp_PoolsReg(7610, p);

   smtpstats_init(); // inicializace

   pth_mutex_t mutex = PTH_MUTEX_INIT;
   pth_mutex_acquire(&mutex, TRUE, NULL);

   now_unixtime = time(NULL);
   gmtime_r(&now_unixtime, &now);

   lcJID=lcFrom;
   
   // najdi dle datumu zda ma JID, pokudne zaloit, pokud ano, inkrementuj
   lcDate = (char*)pmalloc_x(p, 11,' ');
   snprintf(lcDate, j_strlen(lcDate), "%04i-%02i-%02i\0", now.tm_year+1900, now.tm_mon+1, now.tm_mday);
   loDay=xmlnode_get_tag(jtin->smtpstats,spools(p,"day?id=",lcDate,p));
   if (loDay==NULL)
      {
//      SMTP_DEBUG(SMTP_ZONE,"JABSTATS - add day %s",lcDate);
      loDay=xmlnode_insert_tag(jtin->smtpstats,"day");
      xmlnode_put_attrib(loDay,"id",lcDate);
      loJID=NULL;
      } 
   else
      {
//      SMTP_DEBUG(SMTP_ZONE,"JABSTATS - test jid %s of date %s",lcJID,lcDate);
      loJID=xmlnode_get_tag(loDay,spools(p,"jid?from=",lcJID,p));
      } 

   if (loJID==NULL)
      {
//      SMTP_DEBUG(SMTP_ZONE,"JABSTATS - add jid %s",lcJID);
      loJID=xmlnode_insert_tag(loDay,"jid");
      xmlnode_put_attrib(loJID,"from",lcJID);
      xmlnode_put_attrib(loJID,"count","1");
      xmlnode_put_attrib(loJID,"stepover","0");
      lii=1;
      }
   else
      {
//      SMTP_DEBUG(SMTP_ZONE,"JABSTATS - update jid %s",lcJID);
      lii=j_atoi(xmlnode_get_attrib(loJID,"count"),0)+1;
      xmlnode_put_attrib(loJID,"count",smtp_itoa( p,lii));
      }

   // ulo do loJID adresu pjemce
   loRcpt=xmlnode_get_tag(loJID,spools(p,"recipient?to=",lcTo,p));
   if (loRcpt==NULL)
      {
      loRcpt=xmlnode_insert_tag(loJID,"recipient");
      xmlnode_put_attrib(loRcpt,"to",lcTo);
      xmlnode_put_attrib(loRcpt,"count","1");
      }
   else
      {
      lii=j_atoi(xmlnode_get_attrib(loRcpt,"count"),0)+1;
      xmlnode_put_attrib(loRcpt,"count",smtp_itoa( p,lii));
      }

   // vytvo statistiku - kdo a kdy poslal message z smtp
   // <year id="2008">
   //  <day id="yyyymmdd">
   //   <jid from="bla@xx.cz" count="1" >
   //    <recipient to="blah@xx.cz count="1" />
   //   </jid>
   //  </day>
   // </year>

   // nyn otestuj zda nepekroil limit za den
   // limit me bt nastaven individuln pro JID
   liLimit=0;
   if ((loSMTPstats=xmlnode_get_tag(jtin->config,spools(p,"smtp/stats/item?email=",lcJID,p))))
      liLimit=j_atoi(xmlnode_get_attrib(loSMTPstats,"daymaxlimit"),SMTP_SMTPSTATS_DAYMAXLIMIT);
   else if ((loSMTPstats=xmlnode_get_tag(jtin->config,"smtp/stats")))
      liLimit=j_atoi(xmlnode_get_attrib(loSMTPstats,"daymaxlimit"),SMTP_SMTPSTATS_DAYMAXLIMIT);
   

   if (liLimit>0 && lii>=liLimit &&
       j_atoi(xmlnode_get_attrib(loJID,"stepover"),0)==0
      )
      {
      smtp_SendInfoToAdmin(spools(p,"The sender ",lcJID," step over day limit: ",smtp_itoa( p,liLimit),".",p),SMTP_SITA_M );
      xmlnode_put_attrib(loJID,"stepover","1");
      }


   // ulo XML, pes kopii
   loCopy=xmlnode_dup_pool(p,jtin->smtpstats);
   lcFile=spools(p,jtin->smtpstats_folder,"/",xmlnode_get_attrib(jtin->smtpstats,"id"),".xml",p);
   if (xmlnode2file(lcFile,loCopy)!=1)
      {
      log_alert("smtp","SMTPSTATS - Cannot save file %s.",lcFile);
      smtp_SendInfoToAdmin(spools(p,"SMTPSTATS - Cannot save file ",lcFile,".",p ),SMTP_SITA_P);
      }


   pool_free(p);
   pth_mutex_release(&mutex);
   }
